Index: /trunk/src/lib/network/monitor/network_node.h
===================================================================
--- /trunk/src/lib/network/monitor/network_node.h	(revision 9493)
+++ /trunk/src/lib/network/monitor/network_node.h	(revision 9494)
@@ -32,27 +32,27 @@
     void removeMasterServer(PeerInfo* node);
 
-    PeerInfo* getClient(int index);
-    PeerInfo* getActiveProxyServer(int index);
-    PeerInfo* getPassiveProxyServer(int index);
-    PeerInfo* getMasterServer(int index);
+    PeerInfo* getClient(int index) const;
+    PeerInfo* getActiveProxyServer(int index) const;
+    PeerInfo* getPassiveProxyServer(int index) const;
+    PeerInfo* getMasterServer(int index) const;
 
     /** @returns the master server list */
-    inline std::list<PeerInfo*> getMasterServer() { return this->masterServerList; }
+    inline std::list<PeerInfo*> getMasterServer() const { return this->masterServerList; }
     /** @returns the active proxy server list */
-    inline std::list<PeerInfo*> getActiveProxyServer() { return this->activeProxyServerList; }
+    inline std::list<PeerInfo*> getActiveProxyServer() const { return this->activeProxyServerList; }
     /** @returns the passive proxy server list */
-    inline std::list<PeerInfo*> getPassiveProxyServer() { return this->passiveProxyServerList; }
+    inline std::list<PeerInfo*> getPassiveProxyServer() const { return this->passiveProxyServerList; }
     /** @returns the client list */
-    inline std::list<PeerInfo*> getClient() { return this->clientList; }
+    inline std::list<PeerInfo*> getClient() const { return this->clientList; }
 
 
     /** @returns the number of players */
-    inline int getPlayerNumber() { return this->playerNumber; }
+    inline int getPlayerNumber() const { return this->playerNumber; }
     /** @returns the node type of this node */
-    inline int getNodeType() { return this->peerInfo->nodeType; }
+    inline int getNodeType() const { return this->peerInfo->nodeType; }
     /** @returns the peer info of this node */
-    inline PeerInfo* getPeerInfo() { return this->peerInfo; }
+    inline PeerInfo* getPeerInfo() const { return this->peerInfo; }
 
-    void debug(int depth);
+    void debug(int depth) const;
 
 
@@ -60,5 +60,5 @@
     int                          playerNumber;                 //!< localy direct connected player number
     int                          connectionNumber;             //!< number of connections ( can but musn't be equal players)
-    PeerInfo*                    peerInfo;                     //!< the peer informationa about this node
+    PeerInfo*                    peerInfo;                     //!< the peer information about this node
 
     /* network nodes directly connected to this node */
Index: /trunk/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- /trunk/src/lib/network/monitor/network_stats_widget.cc	(revision 9494)
+++ /trunk/src/lib/network/monitor/network_stats_widget.cc	(revision 9494)
@@ -0,0 +1,230 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "network_stats_widget.h"
+#include "network_monitor.h"
+
+#include "multi_type.h"
+
+#include "shell_command.h"
+
+// SHELL_COMMAND(gui, NetworkMonitor, toggleGUI)
+//  ->setAlias("ProxyGui");
+
+
+HostWidget::HostWidget(const std::string& name, const IP& ip)
+    : GLGuiBox(OrxGui::Horizontal)
+{
+  this->setName(name);
+  this->setIP(ip);
+
+  this->pack(&this->_name);
+  this->pack(&this->_ip);
+}
+
+void HostWidget::showing()
+{
+  this->_name.show();
+  this->_ip.show();
+}
+
+void HostWidget::hiding()
+{
+  this->_name.hide();
+  this->_ip.hide();
+}
+
+
+
+//======================================================//
+
+
+ProxyWidget::ProxyWidget(const std::string& proxyName, const IP& ip)
+    : _proxyWidget(proxyName, ip)
+{
+  this->_clientNameWidth = 100.0f;
+  this->pack(&_proxyWidget);
+}
+
+void ProxyWidget::addClient(const std::string& name, const IP& ip)
+{
+  HostWidget* newClient = new HostWidget(name, ip);
+  newClient->setNameWidth(this->_clientNameWidth);
+
+  this->pack(newClient);
+
+  if (this->isVisible())
+    newClient->show();
+}
+
+bool ProxyWidget::removeClient(const IP& ip)
+{
+  std::vector<HostWidget*>::iterator rmIt;
+  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
+  {
+    if (*(*rmIt) == ip)
+    {
+      delete (*rmIt);
+      this->_clients.erase(rmIt);
+      return true;
+    }
+  }
+  return false;
+}
+
+bool ProxyWidget::removeClient(const std::string& name)
+{
+  std::vector<HostWidget*>::iterator rmIt;
+  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
+  {
+    if (*(*rmIt) == name)
+    {
+      delete (*rmIt);
+      this->_clients.erase(rmIt);
+      return true;
+    }
+  }
+  return false;
+
+}
+
+bool ProxyWidget::removeClient(const std::string& name, const IP& ip)
+{
+  std::vector<HostWidget*>::iterator rmIt;
+  for(rmIt = this->_clients.begin(); rmIt != this->_clients.end(); ++rmIt)
+  {
+    if (*(*rmIt) == ip && *(*rmIt) == name)
+    {
+      delete (*rmIt);
+      this->_clients.erase(rmIt);
+      return true;
+    }
+  }
+  return false;
+}
+
+
+void ProxyWidget::setClientNameWidths(float width)
+{
+  this->_clientNameWidth = width;
+  for (unsigned int i = 0; i < this->_clients.size(); ++i)
+    this->_clients[i]->setNameWidth(width);
+}
+
+void ProxyWidget::hiding()
+{
+  this->_proxyWidget.hide();
+  for (unsigned int i = 0; i < this->_clients.size(); ++i)
+    this->_clients[i]->hide();
+}
+
+void ProxyWidget::showing()
+{
+  this->_proxyWidget.show();
+  for (unsigned int i = 0; i < this->_clients.size(); ++i)
+    this->_clients[i]->show();
+}
+
+
+//======================================================//
+
+/**
+ * @brief standard constructor
+ */
+NetworkStatsWidget::NetworkStatsWidget(const NetworkMonitor* monitor)
+    : GLGuiBox(OrxGui::Vertical), _thisHost("myName", IP(127, 0, 0 , 1))
+{
+  this->_monitor = monitor;
+
+  /*
+  this->_bar.setSize2D(100, 30);
+  this->pack(&this->_valueText);
+  this->_bar.setParent2D(&this->_valueText);
+
+  this->_valueText.setChangedTextColor(Color::white);
+
+  //this->setBackgroundTexture("maps/gui_element_background_2.png");
+  this->setBackgroundColor(Color(.5,.5,.5,1));
+
+  //this->_name.setBackgroundTexture(Texture());
+  //this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
+  this->_bar.setBackgroundTexture(Texture());
+  this->_bar.setBackgroundColor(Color(0,0,0,0));
+  this->_bar.setForegroundTexture("maps/gui_element_background_faded.png");
+  this->_bar.setForegroundColor(Color(.5, .5, .5, 1));
+  this->_bar.setChangedValueColor(Color::black);
+  */
+  this->pack(&this->_thisHost);
+
+  this->pack(&this->_upstreamText);
+  this->pack(&this->_downstreamText);
+
+  this->pack(&this->_serverIP);
+}
+
+
+/**
+ * @brief standard deconstructor
+ */
+NetworkStatsWidget::~NetworkStatsWidget ()
+{}
+
+
+void NetworkStatsWidget::setMaximum(float max)
+{
+  // this->_bar.setMaximum(max);
+}
+
+void NetworkStatsWidget::setValue(float value)
+{
+  MultiType val(value);
+  val.setType(MT_INT);
+  /*
+
+  this->_bar.setValue(value);
+  this->_bar.setForegroundColor(Color::slerpHSVColor(Color::red, Color::green, value/this->_bar.maximum()));
+  this->_bar.setFrontColor(Color(1,1,1,1), true);
+  this->_valueText.setText(val.getString());
+  */
+}
+
+
+void NetworkStatsWidget::tick(float dt)
+{
+  assert (this->_monitor->getLocalNode() != NULL);
+  assert(this->_monitor->getLocalNode()->getPeerInfo() != NULL);
+
+  if(this->_monitor->getLocalNode()->getPeerInfo()->connectionMonitor != NULL)
+  {
+    ConnectionMonitor* mon = this->_monitor->getLocalNode()->getPeerInfo()->connectionMonitor;
+
+    this->_upstreamText.setText(MultiType(mon->getOutgoingZippedBandWidth()).getString());
+    this->_downstreamText.setText(MultiType(mon->getIncomingZippedBandWidth()).getString());
+  }
+}
+
+void NetworkStatsWidget::resize()
+{
+  GLGuiBox::resize();
+}
+
+
+void NetworkStatsWidget::showing()
+{}
+
+void NetworkStatsWidget::hiding()
+{}
Index: /trunk/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- /trunk/src/lib/network/monitor/network_stats_widget.h	(revision 9494)
+++ /trunk/src/lib/network/monitor/network_stats_widget.h	(revision 9494)
@@ -0,0 +1,117 @@
+/*!
+ * @file network_stats_widget.h
+ * @brief Definition of an EnergyWidget, that displays a bar and a Text
+*/
+
+#ifndef _NETWORK_STATS_WIDGET_H
+#define _NETWORK_STATS_WIDGET_H
+
+#include "glgui_box.h"
+#include "glgui_bar.h"
+#include "glgui_text.h"
+
+#include "network/ip.h"
+
+class NetworkMonitor;
+
+
+class HostWidget : public OrxGui::GLGuiBox
+{
+  public:
+    HostWidget(const std::string& name, const IP& ip);
+    ~HostWidget() {};
+
+    void setName(const std::string& name) { this->_name.setText(name); };
+    void setIP(const IP& ip) { this->_ip.setText(ip.ipString()); this->_storedIP = ip; };
+
+    void setNameWidth(float width) { this->_name.setLineWidth(width); };
+
+    bool operator==(const IP& ip) const { return (this->_storedIP == ip); };
+    bool operator==(const std::string& name) const { return (this->_name == name); };
+
+  protected:
+    virtual void showing();
+    virtual void hiding();
+
+  private:
+    OrxGui::GLGuiText _name;           //!< The Name of the Proxy server to be displayed.
+    OrxGui::GLGuiText _ip;             //!< The IP of the proxy server.
+    IP                _storedIP;       //!< The ip to compare.
+};
+
+
+class ProxyWidget : public OrxGui::GLGuiBox
+{
+  public:
+    ProxyWidget(const std::string& proxyName, const IP& ip);
+
+    void addClient(const std::string& name, const IP& ip);
+
+    bool removeClient(const IP& ip);
+    bool removeClient(const std::string& name);
+    bool removeClient(const std::string& name, const IP& ip);
+
+    void setClientNameWidths(float width);
+
+
+  protected:
+    virtual void hiding();
+    virtual void showing();
+
+
+  private:
+    HostWidget                _proxyWidget;
+
+    std::vector<HostWidget*>  _clients;
+    float                     _clientNameWidth;
+};
+
+
+
+
+//! A class to display network Statistics.
+class NetworkStatsWidget : public OrxGui::GLGuiBox
+{
+  public:
+    NetworkStatsWidget(const NetworkMonitor* monitor);
+    virtual ~NetworkStatsWidget();
+
+    void setUpstream(unsigned int upstream);
+    void setDownstream(unsigned int upstream);
+    void setIP(const IP& ip);
+
+
+
+    void addProxy(const std::string& name, const IP& proxy);
+
+
+    //void rebuildConnectedHosts(std::vector<hosts> hosts);
+
+    void setMaximum(float max);
+    void setValue(float value);
+
+    virtual void tick(float dt);
+
+  protected:
+    virtual void resize();
+    virtual void showing();
+    virtual void hiding();
+
+  private:
+    const NetworkMonitor*  _monitor;
+
+    HostWidget             _thisHost;
+
+    OrxGui::GLGuiText      _upstreamText;
+    OrxGui::GLGuiText      _downstreamText;
+
+    std::vector<HostWidget*>_connectedProxies;
+
+    OrxGui::GLGuiText       _serverIP;
+
+
+    //OrxGui::GLGuiText       _valueText;
+    //OrxGui::GLGuiBar        _bar;
+};
+
+#endif /* _NETWORK_STATS_WIDGET_H */
Index: /trunk/src/lib/network/netdefs.h
===================================================================
--- /trunk/src/lib/network/netdefs.h	(revision 9493)
+++ /trunk/src/lib/network/netdefs.h	(revision 9494)
@@ -43,7 +43,11 @@
 
 
+
+
 //!< enum indicating the type of the node
 typedef enum {
-  NET_MASTER_SERVER,
+  NET_UNASSIGNED              = -1,
+
+  NET_MASTER_SERVER           =  0,
   NET_PROXY_SERVER_ACTIVE,
   NET_PROXY_SERVER_PASSIVE,
@@ -54,4 +58,5 @@
 } NodeType;
 
+
 //!< enum indicating the type of the network connection (2 protocols supported)
 typedef enum ConnectionType {
@@ -60,10 +65,75 @@
 };
 
-//!< the type of the user id (special number never used elsewhere)
+
+//!< the type of the unique id (special number never used elsewhere)
 typedef enum {
   NET_UID_UNASSIGNED = -1,
+
+  NET_UID_HANDSHAKE  =  0,
+
 
   NET_UID_NUMBER
 } UidType;
 
+
+//!< the network id list
+typedef enum nodeId {
+  NET_ID_UNASSIGNED       =-1,
+
+  NET_ID_MASTER_SERVER    = 0,
+
+  NET_ID_PROXY_SERVER_01  = 1,
+  NET_ID_PROXY_SERVER_02,
+  NET_ID_PROXY_SERVER_03,
+  NET_ID_PROXY_SERVER_04,
+  NET_ID_PROXY_SERVER_05,
+  NET_ID_PROXY_SERVER_06,
+  NET_ID_PROXY_SERVER_07,
+  NET_ID_PROXY_SERVER_08  = 8,
+
+  NET_ID_PROXY_MAX        = 8,
+
+  NET_ID_CLIENT_01        = 9,
+  NET_ID_CLIENT_02,
+  NET_ID_CLIENT_03,
+  NET_ID_CLIENT_04,
+  NET_ID_CLIENT_05,
+  NET_ID_CLIENT_06,
+  NET_ID_CLIENT_07,
+  NET_ID_CLIENT_08,
+  NET_ID_CLIENT_09,
+  NET_ID_CLIENT_10,
+  NET_ID_CLIENT_11,
+  NET_ID_CLIENT_12,
+  NET_ID_CLIENT_13,
+  NET_ID_CLIENT_14,
+  NET_ID_CLIENT_15,
+  NET_ID_CLIENT_16,
+  NET_ID_CLIENT_17,
+  NET_ID_CLIENT_18,
+  NET_ID_CLIENT_19,
+  NET_ID_CLIENT_20,
+  NET_ID_CLIENT_21,
+  NET_ID_CLIENT_22,
+  NET_ID_CLIENT_23,
+  NET_ID_CLIENT_24,
+  NET_ID_CLIENT_25,
+  NET_ID_CLIENT_26,
+  NET_ID_CLIENT_27,
+  NET_ID_CLIENT_28,
+  NET_ID_CLIENT_29,
+  NET_ID_CLIENT_30,
+  NET_ID_CLIENT_31,
+  NET_ID_CLIENT_32,
+  NET_ID_CLIENT_33,
+  NET_ID_CLIENT_34,
+  NET_ID_CLIENT_35,
+  NET_ID_CLIENT_36,
+  NET_ID_CLIENT_37,
+  NET_ID_CLIENT_38,
+  NET_ID_CLIENT_39,
+  NET_ID_CLIENT_40,
+
+  NET_ID_CLIENT_MAX        = 40
+};
 #endif /* _NETDEFS_H */
Index: /trunk/src/lib/network/nettypes.h
===================================================================
--- /trunk/src/lib/network/nettypes.h	(revision 9493)
+++ /trunk/src/lib/network/nettypes.h	(revision 9494)
@@ -5,3 +5,13 @@
 typedef unsigned char byte;
 
+
+//!< this are the network write variable permissions
+typedef enum netPermissions {
+  PERMISSION_MASTER_SERVER = 1,
+  PERMISSION_PROXY_SERVER  = 2,
+  PERMISSION_OWNER         = 4,
+  PERMISSION_ALL           = 8
+};
+
+
 #endif /* __NET_TYPES_H */
Index: /trunk/src/lib/network/network_game_manager.cc
===================================================================
--- /trunk/src/lib/network/network_game_manager.cc	(revision 9493)
+++ /trunk/src/lib/network/network_game_manager.cc	(revision 9494)
@@ -91,5 +91,5 @@
 bool NetworkGameManager::signalNewPlayer( int userId )
 {
-  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer());
+  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServerActive());
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
@@ -168,7 +168,11 @@
 bool NetworkGameManager::delSynchronizeableHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  if ( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer())
-  {
-    PRINTF(2)("Recieved DeleteSynchronizeable message from client %d!\n", userId);
+
+  PRINTF(0)(" del synchronizeable\n");
+
+  if ( SharedNetworkData::getInstance()->isMasterServer() ||
+       SharedNetworkData::getInstance()->isProxyServerActive() && SharedNetworkData::getInstance()->isUserClient(userId))
+  {
+    PRINTF(0)("Recieved DeleteSynchronizeable message from client %d!\n", userId);
     return true;
   }
@@ -213,5 +217,5 @@
   assert( Converter::intToByteArray( uniqueId, buf, INTSIZE ) == INTSIZE );
 
-  MessageManager::getInstance()->sendMessage( MSGID_DELETESYNCHRONIZEABLE, buf, INTSIZE, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+  MessageManager::getInstance()->sendMessage( MSGID_DELETESYNCHRONIZEABLE, buf, INTSIZE, RT_ALL_BUT_ME, 0, MP_HIGHBANDWIDTH );
 }
 
@@ -229,5 +233,5 @@
 bool NetworkGameManager::preferedTeamHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServer());
+  assert( SharedNetworkData::getInstance()->isMasterServer() ||  SharedNetworkData::getInstance()->isProxyServerActive());
 
   int teamId = 0;
@@ -261,5 +265,5 @@
 void NetworkGameManager::prefereTeam( int teamId )
 {
-  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+  if ( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
     setPreferedTeam( SharedNetworkData::getInstance()->getHostID(), teamId );
   else
@@ -305,7 +309,7 @@
 {
   PRINTF(0)("NetworkGameManager::chatMessageHandler %d %d\n", userId, SharedNetworkData::getInstance()->getHostID() );
-  if ( (SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer()) && userId !=  SharedNetworkData::getInstance()->getHostID() )
-  {
-    MessageManager::getInstance()->sendMessage( messageId, data, dataLength, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+  if ( (SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/) && userId !=  SharedNetworkData::getInstance()->getHostID() )
+  {
+    MessageManager::getInstance()->sendMessage( messageId, data, dataLength, RT_ALL_BUT_ME, 0, MP_HIGHBANDWIDTH );
   }
 
@@ -347,8 +351,8 @@
   assert( Converter::stringToByteArray(message, buf+2*INTSIZE, message.length()+INTSIZE) == message.length()+INTSIZE );
 
-  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer())
+  if ( SharedNetworkData::getInstance()->isMasterServer() /*|| SharedNetworkData::getInstance()->isProxyServerActive()*/)
     MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_ME, 0, MP_HIGHBANDWIDTH );
   else
-    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
+    MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_BUT_ME, 0, MP_HIGHBANDWIDTH );
 
 
Index: /trunk/src/lib/network/network_manager.cc
===================================================================
--- /trunk/src/lib/network/network_manager.cc	(revision 9493)
+++ /trunk/src/lib/network/network_manager.cc	(revision 9494)
@@ -101,5 +101,6 @@
 /**
  *  creates a new NetworkStream of server type
- * @param port: number of the TCP port
+ * @param clientPort: number of the TCP/UDP port for client connections
+ * @param proxyPort: number of the TCP/UDP port for proxy connections
  */
 int NetworkManager::createMasterServer(unsigned int port)
@@ -110,5 +111,5 @@
   // create the network stream
   this->networkStream = new NetworkStream(NET_MASTER_SERVER);
-  this->networkStream->createServer( port);
+  this->networkStream->createServer( port, port + 1);
 
   // start the network game manager
@@ -129,15 +130,20 @@
   NetworkSettings::getInstance()->loadData();
 
-  // create the network stream
-  this->networkStream = new NetworkStream(NET_PROXY_SERVER_ACTIVE);
-  this->networkStream->createServer( port);
-  // and connect to the master server for synchronization
-//   this->networkStream->connectToMasterServer(NetworkSettings::getInstance()->getMasterAddr());
-  // and to the other proxy servers
-
+  // create the network stream af
+  this->networkStream = new NetworkStream(NET_PROXY_SERVER_ACTIVE );
+  // first connect to the master server for synchronization
+  this->networkStream->connectToMasterServer(NetworkSettings::getInstance()->getMasterAddr().ipString(), 10000);
+  // start the handshake with the master server
+  this->networkStream->startHandshake(NET_ID_MASTER_SERVER);
+
+  // then start the server
+  this->networkStream->createServer( port, port +1);
+
+
+  // and to the other proxy servers also, this would be very nice if its works
 
 
   // start the network game manager
-  this->networkStream->createNetworkGameManager();
+  //this->networkStream->createNetworkGameManager();
 
 
@@ -165,5 +171,5 @@
   this->networkStream->startHandshake();
 
-  PRINTF(0)("Created Network Client");
+  PRINTF(0)("Created Network Client\n");
   return 1;
 }
Index: /trunk/src/lib/network/network_manager.h
===================================================================
--- /trunk/src/lib/network/network_manager.h	(revision 9493)
+++ /trunk/src/lib/network/network_manager.h	(revision 9494)
@@ -17,9 +17,8 @@
 
 
-/* forward declarations for the header file (include the header via #include "bla.h" in the source file) */
+
 class NetworkStream;
 class Synchronizeable;
-template<typename>
-class tList;
+
 
 /* and here is the class itsself*/
